/*
Uniword.java
This program finds the total number of unique words in a given text
(c) Nitin Diwaker
Ver 0.5
License: GNU GPL v2 (http://www.gnu.org/licenses/gpl.txt)
Date: 6 Jun 2007
*/

import java.io.*;
import java.util.*;

class Uniword
{
	ArrayList unique=new ArrayList(500);
	int count=0;

 	private void generateList(String infile, String outfile)
	{
		try
		{
		//Read the input file
		FileInputStream fin=new FileInputStream(infile);
		int len=fin.available();
		byte buf[]=new byte[len];
		fin.read(buf);
		String s=new String(buf);
		String currentString="";
		StringTokenizer st = new java.util.StringTokenizer(s," :_=+\"\"-?)~/'(][}{*&^%$@!~.\t\n\r\f#,;\'");
		fin.close();
		while(st.hasMoreTokens())
			{
				currentString=st.nextToken().toLowerCase();
				//System.out.println("Is "+currentString+" present: "+ unique.contains(currentString));
				if(!unique.contains(currentString))
				{
					unique.add(currentString);
					++count;
				}
			}
		st=null;
		s=null;
		buf=null;
		//System.out.println(unique);
		System.out.println("$$ Total no of unique words in the above file: " + count+ " $$");
		System.gc();

		// Generate the output file
		FileOutputStream fout=new FileOutputStream(outfile);
		s=unique.toString();
		buf=s.getBytes();
		fout.write(buf);
		fout.close();
		}
		catch(Exception e34)
		{
			System.out.println("\nERROR!\nI think that you specified an wrong input file :-(\nThe exact error thrown by Java is: "+ e34);
			System.exit(2);
		}
	}

	public static void main (String args[])
	{
		System.out.println("\n******************** Uniword 0.5 ********************");
		System.out.println("\tLicense: GNU GPL");
		System.out.println("\tProgram to find unique words in an input file");
		System.out.println("\t(c)2007 Nitin Diwaker");
		System.out.println("\tContact: nitinatindore AT rediffmail.com");
		System.out.println("*****************************************************\n");
		Uniword unq=new Uniword();
		String outfile="";
		switch(args.length)
		{
			case 0:
			System.out.println("ERROR: Please enter the input filename as command line argument\nUsage: java Uniword <filename> [optional_outputfilename]");
			System.out.println("\nProgram will now exit");
			System.exit(1);
			break;

			case 1:
			Random r=new Random();
			outfile=args[0]+"_"+Math.abs(r.nextInt())+".txt";
			System.out.println("Output file name not specified!!\nAssuming a new output filename: "+outfile+"\nWARNING: If the above output file is present, it will be overwritten!!\n\n");
			unq.generateList(args[0],outfile);
			break;

			default:
			unq.generateList(args[0],args[1]);
			outfile=args[1];
		}
		System.out.println("\nJob Done. Your output file is: "+ outfile);
	}
}
